{
#include <iostream.h>
#include <stdio.h>
#include <fstream.h>
#include <math.h>


//---------Calculation of positive ions density-----------

Double_t I = 10*1.e-9; // sense wire currnet (nA)
Double_t L = 3.5; // Horizontal BeamSpotWidth (cm)
Double_t d = 1; // layer width  of wire (cm)
Double_t E = 1000; // Nominal electric field(V/cm) 
Double_t u = 1.09; // positive ions mobility (cm^2/(sec*V))
Double_t rho = 0; // positive ions density 
Double_t w = u*E; // positive ions drift velocity
Double_t e = 1.6*1.e-19; // elementary charge


rho = I/(L*d*w);

cerr << "positive ions density = " << rho << " (C/cm^3) " << endl;


//--------------------------------------------------------


Double_t xmin  = 0; // Drift length(cm)
Double_t xmax  = 4.5; // Drift length(cm)
Double_t step = 1000; // Number of steps // <- change this point!!!!!!!
Double_t no   = (xmax - xmin)/step; // 
Double_t t = 0 ; // electron drift time during no (cm)
Double_t t2 = 0 ; // electron drift time during no (cm)
Double_t ue = 0.866139*1.e6; // electron mobility (cm^2/(sec*V))   //this points
Double_t dt = 0;    //
Double_t dt2 = 0;   //
Double_t dt0 = 0;   //
Double_t Ed = 0; // Distorted electric field(V/cm)
Double_t Ed2 = 0; // Distorted electric field(V/cm)
Double_t e0  = 8.854*1.e-14;    // electric constant
Double_t V   = 4500; // Cahod Voltage (V/cm)
Double_t l   = 4.5;  // Drift region length (cm)
Double_t deltaE = 0;
Double_t i = 0;
Double_t i2 = 0;
Double_t velocool = 0.78*1.e6; // co2-isobutane 90:10 velocity (cm/sec) at (1kV/cm)
Double_t a = 0;



TH2D *c1 = new TH2D("test","test",step,0,5,step,0,5*1e-06);
TH2D *c2 = new TH2D("test2","test2",step,0,5,step,0,5*1e-06);
//TH2D *c3 = new TH2D("test3","test3",step,0,5,step,0,10*1e-05);
TH2D *c3 = new TH2D("test3","test3",step,0,5,step,0,200);
TH2D *c4 = new TH2D("test3","test3",step,0,5,step,900,1100);
dt = 0;  
dt0 = 0;

for ( Double_t x = 0; x < step ; x++){
  
  i = xmin + x*no;  
  Ed = V/l - (rho*l)/(2*e0)+(rho*i)/e0;
  
  i2 = 4.5 - i;
  Ed2 = V/l - (rho*l)/(2*e0)+(rho*i2)/e0;
  //cerr << "Drift Length = " << i << " (cm)" << " " << "Distorted E = " << Ed << " (V/cm)" << endl;
  //cerr << "Drift Length = " << i << " (cm)" << " " << "Nominal E = " << E << " (V/cm)" << endl;
  
  t = no/(ue*Ed);
  t0 = no/(ue*E); // nominal electric field
  t2 = no/(ue*Ed2);
  
  dt += t;
  dt0 += t0;
  dt2 += t2;
  
  
  
  a = (dt  - dt2)*velocool*1.e6; // \Delta{X}_on - \Delta{X}_off (um)
  cerr << "debug = " << a << endl;
  
#if 0
  c1->Fill(i,dt,1.0);
  c2->Fill(i,dt0,1.0);
#else
  //c3->Fill(i,dt - dt0,1.0);
  c3->Fill(i+0.5,a,1.0);
  //c4->Fill(i,Ed,1.0);
#endif

  
  ofstream out;
  out.open("DDXvsDL_simulate.dat",ios::app);
  out << i+0.5 <<" "<< a << " " << 0 << endl; 
     
}

#if 0
c1->Draw();
c1->SetMarkerColor(2);
c1->SetMarkerStyle(8);
c1->SetMarkerSize(0.3);
c1->Draw();
c2->Draw();
c2->SetMarkerColor(4);
c2->SetMarkerStyle(8);
c2->SetMarkerSize(0.3);
c2->Draw();
c1->Draw("same");
#else
c3->Draw();
c3->SetMarkerColor(2);
c3->SetMarkerStyle(8);
c3->SetMarkerSize(0.3);
c3->Draw();
//c4->Draw();
//c4->SetMarkerColor(2);
//c4->SetMarkerStyle(8);
//c4->SetMarkerSize(0.3);
//c4->Draw();
#endif

out.close();
}
   
